import java.util.Objects;

// Tip podataka koji predstavlja jednu osobu
public class Osoba {

	private final String ime;
	private final String prezime;
	private final int godinaRodjenja;

	public Osoba(String ime, String prezime, int godinaRodjenja) {
		if (ime == null) {
			throw new IllegalArgumentException("ime");
		}
		this.ime = ime;
		if (prezime == null) {
			throw new IllegalArgumentException("prezime");
		}
		this.prezime = prezime;
		this.godinaRodjenja = godinaRodjenja;
	}

	public String getIme() {
		return ime;
	}

	public String getPrezime() {
		return prezime;
	}

	public int getGodinaRodjenja() {
		return godinaRodjenja;
	}

	@Override
	public int hashCode() {
		final int prostBroj = 31;
		int rezultat = 1;
		rezultat = prostBroj * rezultat + godinaRodjenja;
		rezultat = prostBroj * rezultat + ime.hashCode();
		rezultat = prostBroj * rezultat + prezime.hashCode();
		return rezultat;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Osoba that = (Osoba) obj;
		if (this.godinaRodjenja != that.godinaRodjenja) {
			return false;
		}
		if (!Objects.equals(this.ime, that.ime)) {
			return false;
		}
		if (!Objects.equals(this.prezime, that.prezime)) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return ime + " " + prezime + " " + godinaRodjenja;
	}
}
